#include "windows.h"
#include "windowsx.h"

UINT const WM_ONINIT = WM_USER;
UINT const WM_FOLDER_CHANGE = WM_USER+1;
UINT const WM_INVALID_HANDLE_VALUE = WM_USER+2;

HWND hMainWnd;
HWND hRagWnd = 0;

char* const MONFOLDERNAME = "commands";
char CommandFilesPath[MAX_PATH] = "";

LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);
HANDLE hThread;
DWORD WINAPI ThreadFunc (LPVOID);

HWND hstat, hlog, hbutp, hbutq;
bool inProgress = false;

typedef struct _ALLFL {
	char* fn;
	HANDLE hThread;
	DWORD ThreadId;
	struct _ALLFL *prev;
	struct _ALLFL *next;
} ALLFL;

ALLFL *tfl, *pfl, *mfl = NULL;

void ttoa (SYSTEMTIME st, char* s)
{
	if (st.wHour < 10)
		strcat (s, "0");
	itoa (st.wHour, s, 10); 
	strcat (s, ":");
	
	if (st.wMinute < 10)
		strcat (s, "0");
	itoa (st.wMinute, s+strlen (s), 10); 
	strcat (s, ":");
	
	if (st.wSecond < 10)
		strcat (s, "0");
	itoa (st.wSecond, s+strlen (s), 10);
	strcat (s, ".");

	if (st.wMilliseconds < 100)
		strcat (s, "0");
	if (st.wMilliseconds < 10)
		strcat (s, "0");
	itoa (st.wMilliseconds, s+strlen (s), 10);
}

BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam)
{
	char s[31];
	if (GetWindowText (hwnd, s, 30))
		if (strcmp(s, "Ragnarok") == 0) 
		{
			hRagWnd = hwnd;
			return false;
		}
	return true;
};

/*
void Add2Log (char* s);

BOOL CALLBACK EnumShowAllWindows(HWND hwnd, LPARAM lParam)
{
	char s[301];
	if (GetWindowText (hwnd, s, 300))
		if (IsWindowVisible (hwnd) == true)
		{
			strcat (s, "\r\n");
			Add2Log (s);
		}
	return true;
};
*/

char* const DIVIDERS = " \t.,:;+=|<>[]{}()\r\n";
char* const ZEROLINES = " \t\r\n";
char* const SPACES = " \t";
char* const OBRACKETS = "<[{(";
char* const CBRACKETS = ">]})";
size_t const BUFLEN = 200;

void Add2Log (char* s)
{
	size_t const MAXLOGLEN = 65000;
	size_t len = strlen (s) + GetWindowTextLength (hlog);
	char *logtext = new char[len+1];
	
	if (GetWindowText (hlog, logtext, len))
		strcat (logtext, s);
	else
		strcpy (logtext, s);

	char *newtext = logtext;
	while ((len = strlen (newtext)) > MAXLOGLEN)
	{
		char *p;
		if ((p = strchr (newtext, '\n')) != 0)
			newtext = p+1;
		else
			newtext = newtext + len-MAXLOGLEN;
	}
	
	if (len > 0)
		SetWindowText (hlog, newtext);
	else
		SetWindowText (hlog, s);

	SendMessage(hlog, WM_VSCROLL, SB_BOTTOM, 0);
	
	delete[] logtext;
}

void send (unsigned char key)
{
	EnumWindows (EnumWindowsProc, 0);

	if (hRagWnd != 0)
	{
		HWND hActWnd = GetForegroundWindow ();
		
		if (hActWnd)
		{
			HWND hCurWnd = hActWnd;
			
			if (hCurWnd != hRagWnd)
			{
				char text[1000] = "";
				//char s[13];
				
				BOOL sc;
				DWORD ec=0;
				
				SYSTEMTIME st1;
				GetLocalTime (&st1);
				
				/*
				HMODULE hLib = GetModuleHandle ("user32");
				if (hLib != NULL)
				{
					void (WINAPI *SwitchToThisWindow) (HWND, BOOL);
					(FARPROC &)SwitchToThisWindow = GetProcAddress (hLib, "SwitchToThisWindow");
					if (SwitchToThisWindow != NULL)
					{
						SwitchToThisWindow (hRagWnd, false);
						sc = 1;
					} else
						Add2Log ("    SwitchToThisWindow()");
				} else
					Add2Log ("   user32.dll");
				*/
				
				if (hCurWnd != hMainWnd)
				{
					/*
					DWORD hMainThread = GetCurrentThreadId();	//GetWindowThreadProcessId (hMainWnd, NULL);
					DWORD hCurThread = GetWindowThreadProcessId (hCurWnd, NULL);
					BOOL Attached = false;
					
					if (hCurThread != hMainThread)
						Attached = AttachThreadInput (hMainThread, hCurThread, true);
					*/
					keybd_event(0,0,0,0);
					
					/*
					if ((sc = SetForegroundWindow (hMainWnd)) == 0)
						ec = GetLastError();
					
					if (Attached)
						AttachThreadInput (hMainThread, hCurThread, false);
					else 
						if (hCurThread != hMainThread)
						{
							ttoa (st1, text);
							strcat (text, "    \r\n");
							strcat (text, "Cur=");
							itoa ((DWORD)hCurThread, s, 16);
							strcat (text, s);
							strcat (text, " ProgMain=");
							itoa ((DWORD)hMainThread, s, 16);
							strcat (text, s);
							strcat (text, "\r\n");
							Add2Log (text);
						}
					*/
				}
				
				if ((sc = SetForegroundWindow (hRagWnd)) == 0)
					ec = GetLastError();
				
				ttoa (st1, text);
				strcat (text, "    \r\n");
				
				int k = 0;
				/*
				while ((sc != 0) && ((hCurWnd = GetForegroundWindow ()) != hRagWnd) && (k++ < 10))
				{
					SYSTEMTIME st2;
					GetLocalTime (&st2);
					ttoa (st2, s);
					strcat (text, s);
					
					strcat (text, " Act=");
					itoa ((DWORD)hActWnd, s, 16);
					strcat (text, s);
					strcat (text, " Cur=");
					itoa ((DWORD)hCurWnd, s, 16);
					strcat (text, s);
					strcat (text, " Rag=");
					itoa ((DWORD)hRagWnd, s, 16);
					strcat (text, s);
					strcat (text, "\r\n");
					
					Sleep (500);
				}
				*/
				
				if (sc == 0)
				{
					LPVOID lpMsgBuf;
					FormatMessage (FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM, NULL,
						ec, MAKELANGID (LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf, 0, NULL);
					Add2Log ((char*) lpMsgBuf);
					Add2Log (" SetForegroundWindow(): ");
					LocalFree (lpMsgBuf);
				}
				
				if ((sc == 0) || (k >= 1))
				{
					if (hCurWnd == hRagWnd)
					{
						// MessageBox (NULL, text, "Ragnarok window is finally activated", MB_OK|MB_ICONINFORMATION);
						Add2Log ("  \r\n");
					}
					
					Add2Log (text);
				}
				
				hCurWnd = hRagWnd;
			}
			
			if (hCurWnd == hRagWnd)
			{
				WINDOWPLACEMENT wp;
				wp.length = sizeof (WINDOWPLACEMENT);
				
				if (GetWindowPlacement (hRagWnd, &wp))	//   
				{
					WINDOWPLACEMENT wpsave = wp;
					if (wp.showCmd != SW_SHOWNORMAL)	//   
					{
						wp.showCmd = SW_RESTORE;
						int n = 0;
						while (SetWindowPlacement (hRagWnd, &wp) && GetWindowPlacement (hRagWnd, &wp) && (wp.showCmd != SW_SHOWNORMAL) && (n++ < 10))
						{
							Sleep (100);
							wp.showCmd = SW_RESTORE;
						}
					}
					
					if (wp.showCmd == SW_SHOWNORMAL)	//   
					{
						keybd_event(key, 0, 0 ,0);
						keybd_event(key, 0, KEYEVENTF_KEYUP,0);
					}
					
					if (wpsave.showCmd != wp.showCmd)	//     
						SetWindowPlacement (hRagWnd, &wpsave);
				}
			}
				
			if (hActWnd != hRagWnd)		//    
				SetForegroundWindow (hActWnd);
		} else
		{
			Add2Log ("     \r\n");
		}	
	}
}

void press (char* keystr)
{
	int const N = 13;
	char* keys[N] = {"F1", "F2", "F3", "F4", "F5", "F6", "F7", "F8", "F9", "F10", "F11", "F12", "ENTER"};
	unsigned char codes[N] = {VK_F1, VK_F2, VK_F3, VK_F4, VK_F5, VK_F6, VK_F7, VK_F8, VK_F9, VK_F10, VK_F11, VK_F12, VK_RETURN};

	int i;
	for (i=0;i<N && strcmp (keystr, keys[i]) != 0; i++);
	if (i < N)
		send (codes[i]);
	else
		if (strlen (keystr) == 1)
			send (keystr[0]);
}

void wait()
{
	Sleep (1000);
}

char* gettok (char* inbuf, char* tok)
{
	size_t len = strcspn (inbuf, DIVIDERS);
	if (len >= BUFLEN)
		len = BUFLEN;
	
	strncpy (tok, inbuf, len);
	tok[len] = 0;
		
	return inbuf+len;
}

char* getval (char* inbuf, char* val)
{
	char* buf = inbuf;// + strspn (inbuf, SPACES);

	char* p = strchr (OBRACKETS, (int)*buf);
	if ((p != NULL) && (p[0] != 0))
	{
		buf = getval (buf+1, val);
		buf = buf + strspn (buf, SPACES);
		
		if (*buf == CBRACKETS[p - OBRACKETS])
			buf = buf+1;
		else
		{
			val[0] = 0;
		}
		
	} else
		buf = gettok (buf, val);
	
	return buf;
}

char* ProcessCommands (char* inbuf)
{
	char *buf = inbuf;
	char tok[BUFLEN];
	char val[BUFLEN];
	char *ret = "";
	
	while (*(buf = buf + strspn (buf, ZEROLINES)))
	{
		buf = gettok (buf, tok);
		
		if (*tok)
		{
			buf = buf + strspn (buf, ZEROLINES);
			
			if (strcmp (tok, "press") == 0)
			{
				buf = getval (buf, val);
				if (*val)
					press (val);
				else
				{
					ret = " ";
					*buf = 0;
				}
			}	
			else if (strcmp (tok, "wait") == 0)
				wait ();
			else
			{
				ret = " ";
				*buf = 0;
			}
		}
		else
		{	
			ret = " ";
			*buf = 0;
		}
	}
	
	return ret;
}

char* ProcessCommandFile (char* filename)
{
	char* ret="";
	HANDLE infhand = CreateFile (filename, GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
	
	if (infhand != NULL)
	{
		DWORD inflen = GetFileSize (infhand, NULL) ;
		if (inflen > 0)
			if (inflen < 0xFFFFF)
			{
				char *inbuf = new char [inflen+1];
				if (inbuf != NULL)
				{
					DWORD readlen;
					if (ReadFile (infhand, inbuf, inflen, &readlen, NULL) && (readlen == inflen))
					{
						inbuf[inflen] = 0;
						ret = ProcessCommands (inbuf);
					} else
						ret = " ";
					
					delete [] inbuf;
				} else
					ret = " ";
			} else
				ret = "  ";
		else
			ret = " ";
		
		CloseHandle (infhand);
	} else
		ret = "  ";
	
	return ret;
}

DWORD WINAPI DeleteFileThreadFunc (LPVOID tparam)
{
	while ((*(char*)tparam != 0) && !DeleteFile((char*)tparam))
		Sleep(10);
	
	return 0;
}

void ProcessCommandFiles (bool doProcess)
{
	inProgress = true;

	//     
	tfl = mfl; pfl = NULL;
	while (tfl != NULL)
	{
		DWORD ExitCode;
		if (GetExitCodeThread (tfl->hThread, &ExitCode) && (ExitCode != STILL_ACTIVE))
		{
			CloseHandle (tfl->hThread);
			
			//     
			if (pfl != NULL) pfl->next = tfl->next;
			if (tfl->next != NULL) tfl->next->prev = tfl->prev;
			if (mfl == tfl) mfl = tfl->next;
			pfl = tfl->prev;
			delete [] tfl->fn;
			delete [] tfl;
			if (pfl != NULL) tfl = pfl->next; else tfl = mfl;
		} else
		{
			pfl = tfl;
			tfl = tfl->next;
		}
	}

	char fullpathname[MAX_PATH];
	strcpy (fullpathname, CommandFilesPath);
	strcat (fullpathname, "\\*");
	
	WIN32_FIND_DATA fd;
	HANDLE hFind = FindFirstFile (fullpathname, &fd);
	bool isnext = (hFind != INVALID_HANDLE_VALUE);
	
	while (isnext)
	{
		if ((fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) != FILE_ATTRIBUTE_DIRECTORY)
		{
			strcpy (fullpathname, CommandFilesPath);
			strcat (fullpathname, "\\");
			strcat (fullpathname, fd.cFileName);
				
			//    
			tfl = mfl; pfl = NULL;
			while ((tfl != NULL) and (strcmp (tfl->fn, fullpathname) != 0))
			{
				pfl = tfl;
				tfl = tfl->next;
			}
			
			if (tfl == NULL)	//         
			{
				char s[2*MAX_PATH] = "";
				
				if (doProcess)
				{
					SYSTEMTIME st;
					GetLocalTime (&st);
					ttoa (st, s);
					strcat (s, " ");
					
					strcat (s, fd.cFileName);
					strcat (s, " ");
					
					char* res = ProcessCommandFile (fullpathname);
					strcat (s, res);
					strcat (s, " ");
					strcat (s, "\r\n");
					
					Add2Log (s);
				}
				
				if (!DeleteFile (fullpathname))	//    ,     
				{
					tfl = new ALLFL[1];
					tfl->prev = pfl;
					tfl->next = NULL;
					
					if (mfl == NULL) mfl = tfl;
					if (pfl != NULL) pfl->next = tfl;
					
					tfl->fn = new char[strlen(fullpathname)+1];
					strcpy (tfl->fn, fullpathname);
					
					tfl->hThread = CreateThread (NULL, 0, DeleteFileThreadFunc, tfl->fn, 0, &tfl->ThreadId);
				}
			}
		}	
		isnext = FindNextFile (hFind, &fd);
	}

	if (hFind != INVALID_HANDLE_VALUE) 
		FindClose (hFind);
	
	inProgress = false;
}

int APIENTRY WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASS w;
	memset(&w,0,sizeof(WNDCLASS));
	w.style = CS_HREDRAW | CS_VREDRAW;
	w.lpfnWndProc = WndProc;
	w.hInstance = hInstance;
	w.hIcon = LoadIcon (NULL, IDI_APPLICATION);
	w.hCursor = LoadCursor (NULL, IDC_ARROW);
	w.hbrBackground = GetStockBrush (LTGRAY_BRUSH);
	w.lpszClassName = "RagKey";
	RegisterClass(&w);
	
	hMainWnd = CreateWindow ("RagKey", "RagKey",
		WS_MINIMIZEBOX|WS_VISIBLE|WS_CLIPCHILDREN|WS_CLIPSIBLINGS|WS_CAPTION|WS_BORDER|WS_SYSMENU,
		CW_USEDEFAULT,0,300,410,NULL,NULL,hInstance,NULL);
	ShowWindow (hMainWnd, nCmdShow);
	
	hstat = CreateWindowEx (0, "STATIC", "Ragnarok Online",
		ES_CENTER|WS_VISIBLE|WS_CHILD, 7, 5, 280, 16, hMainWnd, NULL, hInstance, NULL);
	
	hlog = CreateWindowEx (WS_EX_CLIENTEDGE, "EDIT", "",
		ES_LEFT|ES_MULTILINE|ES_AUTOVSCROLL|ES_AUTOHSCROLL|WS_VISIBLE|WS_CHILD|ES_READONLY|WS_VSCROLL,
		7, 30, 280, 311, hMainWnd, NULL, hInstance, NULL);
		
	hbutp = CreateWindowEx (0, "BUTTON", "",
		BS_PUSHBUTTON|WS_VISIBLE|WS_CHILD|WS_TABSTOP, 25, 351, 95, 25, hMainWnd, NULL, hInstance, NULL);
	hbutq = CreateWindowEx (0, "BUTTON", "",
		BS_PUSHBUTTON|WS_VISIBLE|WS_CHILD|WS_TABSTOP, 175, 351, 95, 25, hMainWnd, NULL, hInstance, NULL);
	
	HFONT fnt = CreateFont (-12,0,0,0,FW_NORMAL,0,0,0,DEFAULT_CHARSET,
		OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
		DEFAULT_PITCH|FF_DONTCARE, "Arial");
	
	SendMessage(hlog, WM_SETFONT, (WPARAM)fnt, 0);

	//UpdateWindow (hMainWnd);
	
	if (GetCurrentDirectory (MAX_PATH, CommandFilesPath))
	{
		strcat (CommandFilesPath, "\\");
		strcat (CommandFilesPath, MONFOLDERNAME);
		
		WIN32_FIND_DATA fd;
		HANDLE hFind = FindFirstFile (CommandFilesPath, &fd);
		if (hFind != INVALID_HANDLE_VALUE)
		{
			if ((fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == FILE_ATTRIBUTE_DIRECTORY)
				ProcessCommandFiles (false);
			FindClose (hFind);
		} else
			CreateDirectory (CommandFilesPath, NULL);
	}
	
//	EnumWindows (EnumShowAllWindows, 0);
//	PostMessage (hMainWnd, WM_ONINIT, 0, 0); 
	
	DWORD ThreadId;
	bool ThreadFlag = true;
	if ((hThread = CreateThread (NULL, 0, ThreadFunc, &ThreadFlag, 0, &ThreadId)) != NULL)
	{
		MSG msg;
		while (GetMessage (&msg,NULL,0,0))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		
		ThreadFlag = false;
		WaitForSingleObject (hThread, INFINITE);
		CloseHandle (hThread);
		
		/*      */
		tfl = mfl;
		while ((tfl != NULL) && (tfl->next != NULL)) tfl = tfl->next;
		/*    ,    */
		while (tfl != NULL)
		{
			DWORD ExitCode;
			if (GetExitCodeThread (tfl->hThread, &ExitCode))
			{
				if (ExitCode == STILL_ACTIVE)
				{
					*tfl->fn = 0;
					WaitForSingleObject (tfl->hThread, INFINITE);
				}
				CloseHandle (tfl->hThread);
			}
			
			pfl = tfl->prev;
			delete [] tfl->fn;
			delete [] tfl;
			tfl = pfl;
		}
		
		return msg.wParam;
	} else
	{
		MessageBox (hMainWnd, "     ", " ", MB_OK|MB_ICONERROR);
		return GetLastError();
	}
}

DWORD WINAPI ThreadFunc (LPVOID tparam)
{
	HANDLE hDir = FindFirstChangeNotification (CommandFilesPath, false, FILE_NOTIFY_CHANGE_LAST_WRITE);
	if (hDir != INVALID_HANDLE_VALUE)
	{
		while (*(bool*)tparam)
		{
			DWORD dwWaitStatus = WaitForSingleObject (hDir, 1000);
			if (dwWaitStatus == WAIT_OBJECT_0)
			{
				if (*(bool*)tparam)
				{
					PostMessage (hMainWnd, WM_FOLDER_CHANGE, 0, 0); 
					FindNextChangeNotification (hDir);
				}
			}
		}
		FindCloseChangeNotification (hDir);
	} else
		PostMessage (hMainWnd, WM_INVALID_HANDLE_VALUE, GetLastError(), 0); 
	
	return 0;
}

LRESULT CALLBACK WndProc (HWND hwnd, UINT Message, WPARAM wparam, LPARAM lparam)
{
	switch (Message)
	{
		case WM_CLOSE:
			PostQuitMessage(0);
			break;
		case WM_SHOWWINDOW:
			//MessageBox (NULL, "ShowWindow", "ShowWindow", MB_OK|MB_ICONERROR);
			break;
		case WM_ONINIT:			
//			EnumWindows (EnumShowAllWindows, 0);
			break;
		case WM_COMMAND:
			if ((HWND)lparam == hbutp)
			{
				ProcessCommandFiles (true);
//				ProcessCommandFiles (false);
			}
			if ((HWND)lparam == hbutq)
				PostQuitMessage(0);
			break;
			
		case WM_FOLDER_CHANGE:
			if (!inProgress)
				ProcessCommandFiles (true);
			break;
			
		case WM_INVALID_HANDLE_VALUE:
			LPVOID lpMsgBuf;
			FormatMessage (FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM, NULL,
				wparam, MAKELANGID (LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf, 0, NULL);
			char* t = new char[100 + strlen((char*)lpMsgBuf)];
			
			strcpy (t, " FindFirstChangeNotification():\n\n");
			strcat (t, (char*)lpMsgBuf);
			strcat (t, "\n,      .");
			
			MessageBox (NULL, t, " ", MB_OK|MB_ICONERROR);
			delete[] t;
			LocalFree (lpMsgBuf);
					
			PostQuitMessage(0);
			return wparam;
	}
	return DefWindowProc(hwnd,Message,wparam,lparam);
}
